#line 1 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F887/TestGLCD/TestDataTransfer/TestData.c"
#line 22 "C:/Users/raj/Desktop/EmbeddedLab_Code/MikroC_PIC/PIC16F887/TestGLCD/TestDataTransfer/TestData.c"
sbit GLCD_CS1 at RB0_bit;
sbit GLCD_CS2 at RB1_bit;
sbit GLCD_RS at RB2_bit;
sbit GLCD_RW at RB3_bit;
sbit GLCD_RST at RB4_bit;
sbit GLCD_EN at RB5_bit;

sbit GLCD_CS1_Direction at TRISB0_bit;
sbit GLCD_CS2_Direction at TRISB1_bit;
sbit GLCD_RS_Direction at TRISB2_bit;
sbit GLCD_RW_Direction at TRISB3_bit;
sbit GLCD_RST_Direction at TRISB4_bit;
sbit GLCD_EN_Direction at TRISB5_bit;


void Enable_Pulse()
{
 GLCD_EN = 1;
 delay_us(5);
 GLCD_EN = 0;
 delay_us(5);
}

void GLCD_ON()
{

 GLCD_CS1 = 0;
 GLCD_CS2 = 0;
 GLCD_RS = 0;
 GLCD_RW = 0;
  PORTD  = 0x3F;
 Enable_Pulse();
}

void Set_Start_Line(unsigned short line)
{
 GLCD_RS = 0;
 GLCD_RW = 0;

 GLCD_CS1 = 0;
 GLCD_CS2 = 0;
  PORTD  = 0xC0 | line;
 Enable_Pulse();
}

void GOTO_COL(unsigned int x)
{
 unsigned short Col_Data;
 GLCD_RS = 0;
 GLCD_RW = 0;
 if(x<64)
 {
 GLCD_CS1 = 0;
 GLCD_CS2 = 1;
 Col_Data = x;
 }
 else
 {

 GLCD_CS2 = 0;
 GLCD_CS1 = 1;
 Col_Data = x-64;
 }
 Col_Data = (Col_Data | 0x40 ) & 0x7F;
  PORTD  = Col_Data;
 Enable_Pulse();
}

void GOTO_ROW(unsigned int y)
{
 unsigned short Col_Data;
 GLCD_RS = 0;
 GLCD_RW = 0;
 Col_Data = (y | 0xB8 ) & 0xBF;
  PORTD  = Col_Data;
 Enable_Pulse();
}

void GOTO_XY(unsigned int x,unsigned int y)
{
 GOTO_COL(x);
 GOTO_ROW(y);
}

void GLCD_Write(unsigned short b)
{
 GLCD_RS = 1;
 GLCD_RW = 0;
  PORTD  = b;
 delay_us(1);
 Enable_Pulse();
}

unsigned short GLCD_Read(unsigned short column)
{
 unsigned short read_data = 0;
  TRISD  = 0xFF;
 GLCD_RW = 1;
 GLCD_RS = 1;
 GLCD_CS1 = (column>63);
 GLCD_CS2 = !GLCD_CS1;
 delay_us(1);
 GLCD_EN = 1;
 delay_us(1);


 GLCD_EN = 0;
 delay_us(5);
 GLCD_EN = 1;
 delay_us(1);

 read_data =  PORTD ;
 GLCD_EN = 0;
 delay_us(1);
  TRISD  = 0x00;
 return read_data;
}

 void GLCD_Clrln(unsigned short ln)
 {
 int i;
 GOTO_XY(0,ln);
 GOTO_XY(64,ln);
 GLCD_CS1 = 0;
 for(i=0;i<65;i++)
 GLCD_Write(0);
 }



void GLCD_CLR()
{
 unsigned short m;
 for(m=0;m<8;m++){
 GLCD_Clrln(m);
 }
}

void Draw_Point(unsigned short x,unsigned short y, unsigned short color)
{
 unsigned short Col_Data;;
 GOTO_XY(x,(y/8));
 switch (color)
 {
 case 0:
 Col_Data = ~(1<<(y%8)) & GLCD_Read(x);
 break;
 case 1:
 Col_Data = (1<<(y%8)) | GLCD_Read(x);
 break;
 }
 GOTO_XY(x,(y/8));
 GLCD_Write(Col_Data);
}

void main() {
 unsigned short u, v;
 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 TRISD = 0x00;
 TRISB = 0x00;
 PORTB = 0x00;
 PORTD = 0x00;
 GLCD_CS1 = 1;
 GLCD_CS2 = 1;
 GLCD_RST = 1;
 GLCD_ON();
 GLCD_CLR();
 Set_Start_Line(0);
 do {

 for(u=0; u<64; u+=6)
 for (v=0; v<128; v+=2)
 Draw_Point(v, u, 1);
 delay_ms(1000);
 GLCD_CLR();
 delay_ms(1000);

 } while(1);
}
